_TITLE "Base-256 Text To Custom Number Bases"
DEFLNG A-Z
FOR X = 0 TO 255
    Base256$ = Base256$ + CHR$(X)
NEXT X
FOR X = 32 TO 126
    Base98$ = Base98$ + CHR$(X)
NEXT X
Base98$ = CHR$(9) + CHR$(10) + CHR$(13) + Base98$
CRLF$ = CHR$(13) + CHR$(10)
_CONTROLCHR OFF
VIEW PRINT
COLOR 14
CLS
LOCATE 1, 22, 1
COLOR 9
PRINT "BASE-256 TEXT TO CUSTOM NUMBER BASES";
LOCATE 3, 1
COLOR 14
PRINT "<B>";
COLOR 2
PRINT "ase-10, ";
COLOR 14
PRINT "<D>";
COLOR 2
PRINT "NA, ";
COLOR 14
PRINT "<H>";
COLOR 2
PRINT "EX, ";
COLOR 14
PRINT "<N>";
COLOR 2
PRINT "umbers/Alpha, or ";
COLOR 14
PRINT "<R>";
COLOR 2
PRINT "oman Numerals: ";
GOSUB Prompt1
DO
    _LIMIT 25
    ChosenBase$ = UCASE$(INKEY$)
    IF LEN(ChosenBase$) THEN
        IF ChosenBase$ = "Q" THEN
            SYSTEM
        ELSEIF INSTR("BDHNR", ChosenBase$) THEN
            EXIT DO
        END IF
    END IF
LOOP
PRINT "<"; ChosenBase$; ">";
IF ChosenBase$ = "B" THEN
    BaseChosen$ = "Base-10"
    Base$ = "0123456789"
ELSEIF ChosenBase$ = "D" THEN
    BaseChosen$ = "DNA"
    Base$ = "GCAT"
ELSEIF ChosenBase$ = "H" THEN
    BaseChosen$ = "HEX"
    Base$ = "0123456789ABCDEF"
ELSEIF ChosenBase$ = "N" THEN
    BaseChosen$ = "Numbers/Alpha"
    FOR X = 48 TO 57
        Base$ = Base$ + CHR$(X) ' *** Numbers 0 through 9 ***
    NEXT X
    FOR X = 65 TO 90
        Base$ = Base$ + CHR$(X) ' *** Upper Case Letters ***
    NEXT X
    FOR X = 97 TO 122
        Base$ = Base$ + CHR$(X) ' *** Lower Case Letters ***
    NEXT X
ELSE
    BaseChosen$ = "Roman Numerals"
    Base$ = "IVXLCDM"
END IF
'
WhatChoice:
'
VIEW PRINT 5 TO 24
COLOR 14
CLS
PRINT "<T>";
COLOR 2
PRINT "ext to "; BaseChosen$; " OR ";
COLOR 14
PRINT "<"; ChosenBase$; ">";
COLOR 2
PRINT MID$(BaseChosen$, 2); " to Text: ";
GOSUB Prompt2
DO
    _LIMIT 25
    Choice$ = UCASE$(INKEY$)
    IF LEN(Choice$) THEN
        IF Choice$ = CHR$(13) THEN
            RUN
        ELSEIF INSTR("T", Choice$) OR INSTR(ChosenBase$, Choice$) THEN
            EXIT DO
        END IF
    END IF
LOOP
PRINT "<"; Choice$; ">";
IF Choice$ = "T" THEN
    FromBaseSet$ = Base256$
    ToBaseSet$ = Base$
ELSE
    FromBaseSet$ = Base$
    ToBaseSet$ = Base256$
END IF
FromBaseMantissa = LEN(FromBaseSet$)
ToBaseMantissa = LEN(ToBaseSet$)
IF Choice$ = ChosenBase$ THEN
    GOTO NumbersToText
END IF
'
TextToNumbers:
'
VIEW PRINT 7 TO 24
COLOR 14
CLS
COLOR 2
PRINT "Enter Up to Three Lines of Text (240 Characters Maximum) OR ";
COLOR 14
PRINT "<P>";
COLOR 2
PRINT "aste Clipboard:";
LOCATE 9, 1, 1
GOSUB Prompt2
VIEW PRINT 9 TO 24
FromBaseNumber$ = ""
DO
    An$ = INPUT$(1)
    IF LEN(An$) THEN
        IF An$ = CHR$(8) THEN
            IF LEN(FromBaseNumber$) THEN
                FromBaseNumber$ = LEFT$(FromBaseNumber$, LEN(FromBaseNumber$) - 1)
                CLS
                GOSUB Prompt2
                FOR X = 1 TO LEN(FromBaseNumber$)
                    IF MID$(FromBaseNumber$, X, 1) = CHR$(9) THEN
                        PRINT SPC(8);
                    ELSE
                        PRINT MID$(FromBaseNumber$, X, 1);
                    END IF
                NEXT X
            END IF
        ELSEIF An$ = CHR$(13) THEN
            EXIT DO
        ELSE
            FromBaseNumber$ = FromBaseNumber$ + An$
            IF An$ = CHR$(9) THEN
                PRINT SPC(8);
            ELSE
                PRINT An$;
            END IF
        END IF
    END IF
LOOP
IF FromBaseNumber$ = "" THEN
    GOTO WhatChoice
ELSEIF FromBaseNumber$ = "P" OR FromBaseNumber$ = "p" THEN
    FromBaseNumber$ = _CLIPBOARD$
    '
    CheckIt1:
    '
    IF RIGHT$(FromBaseNumber$, 2) = CRLF$ THEN
        FromBaseNumber$ = LEFT$(FromBaseNumber$, LEN(FromBaseNumber$) - 2)
        GOTO CheckIt1
    END IF
    VIEW PRINT 9 TO 12
    PRINT FromBaseNumber$;
ELSEIF LEN(FromBaseNumber$) > 240 THEN
    GOTO TextToNumbers
END IF
VIEW PRINT 14 TO 24
CLS
LOCATE 14, 1, 0
COLOR 31
PRINT "Verifying...";
Flag% = 0
FOR X = 1 TO (LEN(FromBaseNumber$))
    IF INSTR(Base98$, MID$(FromBaseNumber$, X, 1)) = 0 THEN
        Flag% = -1
        EXIT FOR
    END IF
NEXT X
IF Flag% THEN
    LOCATE 14, 1
    PRINT SPC(12);
    LOCATE 24, 12, 0
    COLOR 15
    PRINT "Invalid - NOT Typing Text Data - Hit ";
    COLOR 30
    PRINT "<Esc>";
    COLOR 15
    PRINT " to Try Again";
    DO
        _LIMIT 25
        An$ = INKEY$
        IF LEN(An$) THEN
            IF An$ = CHR$(27) THEN
                GOTO TextToNumbers
            END IF
        END IF
    LOOP
END IF
GOSUB Engine
VIEW PRINT 14 TO 14
CLS
COLOR 2
PRINT "Text to Base:";
COLOR 14
PRINT ToBaseMantissa;
VIEW PRINT 16 TO 23
FOR X = 1 TO LEN(ToBaseNumber$)
    PRINT MID$(ToBaseNumber$, X, 1);
NEXT X
'
WhatToDo1:
'
LOCATE 25, 11, 1
PRINT "<C>";
COLOR 2
PRINT "opy to Clipboard, ";
COLOR 14
PRINT "<A>";
COLOR 2
PRINT "nother Conversion, or ";
COLOR 14
PRINT "<R>";
COLOR 2
PRINT "estart: ";
DO
    _LIMIT 25
    An$ = UCASE$(INKEY$)
    IF LEN(An$) THEN
        IF INSTR("CAR", An$) THEN
            EXIT DO
        END IF
    END IF
LOOP
COLOR 14
LOCATE 25, 68, 0
PRINT "<"; An$; ">";
_DELAY .5
LOCATE 25, 68
PRINT SPC(3);
IF An$ = "R" THEN
    RUN
ELSEIF An$ = "C" THEN
    _CLIPBOARD$ = ToBaseNumber$ + CRLF$ + CRLF$
    GOTO WhatToDo1
ELSEIF An$ = "A" THEN
    ToBaseNumber$ = ""
    GOTO TextToNumbers
END IF
'
NumbersToText:
'
VIEW PRINT 7 TO 24
COLOR 14
CLS
LOCATE 7, 1, 1
COLOR 2
PRINT "Hit ";
COLOR 14
PRINT "<Enter>";
COLOR 2
PRINT " to Go Back Up OR ";
COLOR 14
PRINT "<P>";
COLOR 2
PRINT "aste From the Clipboard: ";
DO
    _LIMIT 25
    An$ = UCASE$(INKEY$)
    IF LEN(An$) THEN
        IF An$ = CHR$(13) THEN
            GOTO WhatChoice
        ELSEIF An$ = "P" THEN
            EXIT DO
        END IF
    END IF
LOOP
COLOR 14
PRINT "<P>";
VIEW PRINT 9 TO 9
COLOR 14
CLS
FromBaseNumber$ = _CLIPBOARD$
'
CheckIt2:
'
IF RIGHT$(FromBaseNumber$, 2) = CRLF$ THEN
    FromBaseNumber$ = LEFT$(FromBaseNumber$, LEN(FromBaseNumber$) - 2)
    GOTO CheckIt2
END IF
COLOR 2
PRINT "Number From Base:";
COLOR 14
PRINT FromBaseMantissa;
VIEW PRINT 11 TO 14
PRINT FromBaseNumber$;
VIEW PRINT 16 TO 24
LOCATE 16, 1, 0
COLOR 31
PRINT "Verifying...";
Flag% = 0
FOR X = 1 TO (LEN(FromBaseNumber$))
    IF INSTR(FromBaseSet$, MID$(FromBaseNumber$, X, 1)) = 0 THEN
        Flag% = -1
        EXIT FOR
    END IF
NEXT X
IF Flag% THEN
    LOCATE 16, 1
    PRINT SPC(12);
    LOCATE 24, 21, 0
    COLOR 15
    PRINT "Invalid Number, Hit ";
    COLOR 30
    PRINT "<Esc>";
    COLOR 15
    PRINT " to Try Again";
    DO
        _LIMIT 25
        An$ = INKEY$
        IF LEN(An$) THEN
            IF An$ = CHR$(27) THEN
                GOTO NumbersToText
            END IF
        END IF
    LOOP
END IF
GOSUB Engine
VIEW PRINT 16 TO 16
CLS
COLOR 2
PRINT "To Text:";
VIEW PRINT 18 TO 23
COLOR 14
FOR X = 1 TO LEN(ToBaseNumber$)
    PRINT MID$(ToBaseNumber$, X, 1);
NEXT X
'
WhatToDo2:
'
LOCATE 25, 11, 1
PRINT "<C>";
COLOR 2
PRINT "opy to Clipboard, ";
COLOR 14
PRINT "<A>";
COLOR 2
PRINT "nother Conversion, or ";
COLOR 14
PRINT "<R>";
COLOR 2
PRINT "estart: ";
DO
    _LIMIT 25
    An$ = UCASE$(INKEY$)
    IF LEN(An$) THEN
        IF INSTR("CAR", An$) THEN
            EXIT DO
        END IF
    END IF
LOOP
COLOR 14
LOCATE 25, 68, 0
PRINT "<"; An$; ">";
_DELAY .5
LOCATE 25, 68
PRINT SPC(3);
IF An$ = "R" THEN
    RUN
ELSEIF An$ = "C" THEN
    _CLIPBOARD$ = ToBaseNumber$ + CRLF$ + CRLF$
    GOTO WhatToDo2
ELSEIF An$ = "A" THEN
    ToBaseNumber$ = ""
    GOTO NumbersToText
END IF
'
Engine:
'
Power = (LEN(FromBaseNumber$)) - 1
Counter = 1
FOR X = 1 TO (LEN(FromBaseNumber$))
    Weight = INSTR(FromBaseSet$, MID$(FromBaseNumber$, X, 1)) - 1
    IF Power > 0 THEN
        Product$ = MID$(STR$(FromBaseMantissa), 2)
    ELSE
        GOTO BigWork
    END IF
    FOR Y = 2 TO Power
        TopNumber$ = Product$
        BottomNumber$ = MID$(STR$(FromBaseMantissa), 2)
        GOSUB MultiplyRoutine
    NEXT Y
    TopNumber$ = Product$
    BottomNumber$ = MID$(STR$(Weight), 2)
    GOSUB MultiplyRoutine
    IF Value$ = "" THEN
        Value$ = Product$
        GOTO Bypass3
    END IF
    TopNumber$ = Value$
    BottomNumber$ = Product$
    GOSUB AddRoutine
    '
    Bypass3:
    '
    Counter = Counter + 1
    IF Choice$ = "T" THEN
        LOCATE 14, 1, 0
    ELSE
        LOCATE 16, 1, 0
    END IF
    COLOR 2
    PRINT "Converting Byte:";
    COLOR 14
    PRINT Counter;
    COLOR 2
    PRINT "Of";
    COLOR 14
    PRINT LEN(FromBaseNumber$);
    COLOR 2
    PRINT "Bytes";
    Power = Power - 1
    _DELAY .05
NEXT X
'
BigWork:
'
TopNumber$ = Value$
BottomNumber$ = MID$(STR$(Weight), 2)
GOSUB AddRoutine
'
' *** Routine For Dividing w/Remainder ***
Divide:
'
Q = INT(VAL(LEFT$(Value$, 1)) / ToBaseMantissa)
IF Q >= 1 THEN
    Quotient$ = RIGHT$(STR$(Q), 1)
END IF
Q = 0
R = VAL(LEFT$(Value$, 1)) MOD ToBaseMantissa
FOR X = 2 TO (LEN(Value$))
    IF R > 0 THEN
        Temp$ = MID$(STR$(R), 2) + MID$(Value$, X, 1)
    ELSE
        Temp$ = MID$(Value$, X, 1)
    END IF
    Q = INT(VAL(Temp$) / ToBaseMantissa)
    IF Q = 0 AND Quotient$ = "" THEN
        GOTO Bypass4
    END IF
    Quotient$ = Quotient$ + RIGHT$(STR$(Q), 1)
    '
    Bypass4:
    '
    R = VAL(Temp$) MOD ToBaseMantissa
NEXT X
ToBaseNumber$ = MID$(ToBaseSet$, R + 1, 1) + ToBaseNumber$
IF Quotient$ = "" THEN
    Value$ = ""
ELSE
    Value$ = Quotient$
    Quotient$ = ""
    GOTO Divide
END IF
'
FOR X = 1 TO LEN(FromBaseNumber$)
    IF MID$(FromBaseNumber$, X, 1) <> LEFT$(FromBaseSet$, 1) THEN
        Begin = 1
        EXIT FOR
    END IF
NEXT X
IF Begin = 0 THEN
    Begin = 2
END IF
FOR X = Begin TO LEN(FromBaseNumber$)
    IF MID$(FromBaseNumber$, X, 1) = LEFT$(FromBaseSet$, 1) THEN
        LeadingZero = LeadingZero + 1
    ELSE
        EXIT FOR
    END IF
NEXT X
IF LeadingZero THEN
    ToBaseNumber$ = STRING$(LeadingZero, LEFT$(ToBaseSet$, 1)) + ToBaseNumber$
END IF
Begin = 0
LeadingZero = 0
RETURN
'
MultiplyRoutine:
'
Product$ = ""
IF (LEN(TopNumber$)) < (LEN(BottomNumber$)) THEN
    SWAP TopNumber$, BottomNumber$
END IF
REDIM Row$(1 TO (LEN(BottomNumber$)))
Zero$ = STRING$((LEN(BottomNumber$)), "0")
FOR M = (LEN(BottomNumber$)) TO 1 STEP -1
    BottomNumber = VAL(MID$(BottomNumber$, M, 1))
    FOR N = (LEN(TopNumber$)) TO 1 STEP -1
        TopNumber = VAL(MID$(TopNumber$, N, 1))
        BottomTimesTop = BottomNumber * TopNumber + Carry
        Carry = 0
        IF BottomTimesTop > 9 THEN
            Carry = VAL(MID$(STR$(BottomTimesTop), 2, 1))
        END IF
        Row$(M) = RIGHT$(STR$(BottomTimesTop), 1) + Row$(M)
    NEXT N
    IF Carry > 0 THEN
        Row$(M) = RIGHT$(STR$(Carry), 1) + Row$(M)
        Carry = 0
    END IF
    Row$(M) = Row$(M) + MID$(Zero$, M + 1, (LEN(Zero$)))
NEXT M
FOR M = (LEN(BottomNumber$)) TO 1 STEP -1
    Row$(M) = MID$(Zero$, 1, (LEN(Row$(1))) - (LEN(Row$(M)))) + Row$(M)
NEXT M
FOR M = (LEN(Row$(1))) TO 1 STEP -1
    Add = Carry
    Carry = 0
    FOR N = 1 TO (LEN(BottomNumber$))
        Add = Add + VAL(MID$(Row$(N), M, 1))
    NEXT N
    IF Add > 9 THEN
        Carry = VAL(MID$(STR$(Add), 2, (LEN(STR$(Add))) - 2))
    END IF
    Product$ = RIGHT$(STR$(Add), 1) + Product$
NEXT M
IF Carry > 0 THEN
    Product$ = MID$(STR$(Add), 2, (LEN(STR$(Add))) - 2) + Product$
    Carry = 0
END IF
RETURN
'
AddRoutine:
'
Value$ = ""
IF (LEN(TopNumber$)) < (LEN(BottomNumber$)) THEN
    SWAP TopNumber$, BottomNumber$
END IF
IF (LEN(TopNumber$)) > (LEN(BottomNumber$)) THEN
    BottomNumber$ = STRING$((LEN(TopNumber$)) - (LEN(BottomNumber$)), "0") + BottomNumber$
END IF
FOR M = (LEN(TopNumber$)) TO 1 STEP -1
    Add = Carry
    Carry = 0
    Add = Add + VAL(MID$(TopNumber$, M, 1)) + VAL(MID$(BottomNumber$, M, 1))
    IF Add > 9 THEN
        Carry = 1
    END IF
    Value$ = RIGHT$(STR$(Add), 1) + Value$
NEXT M
IF Carry > 0 THEN
    Value$ = "1" + Value$
    Carry = 0
END IF
RETURN
'
Prompt1:
'
SavedColumn = POS(0)
SavedRow = CSRLIN
LOCATE 24, 32
COLOR 15
PRINT "Hit ";
COLOR 30
PRINT "<Q>";
COLOR 15
PRINT " to Quit";
LOCATE SavedRow, SavedColumn
COLOR 14
RETURN
'
Prompt2:
'
SavedColumn% = POS(0)
SavedRow% = CSRLIN
LOCATE 24, 27
COLOR 15
PRINT "Hit ";
COLOR 30
PRINT "<Enter>";
COLOR 15
PRINT " to Go Back Up";
LOCATE SavedRow%, SavedColumn%
COLOR 14
RETURN




